#ifndef __BPOP_MAIN_H__
#define __BPOP_MAIN_H__

#include "raylib.h"
#include "raymath.h"
#include "rlgl.h"
#include <stdint.h>

#define MAX_BUBBLE_TYPES 3

typedef struct Bubble
{
    uint8_t flagIsActive:1;
    uint8_t sameLevelContact:1;
    uint8_t bubbleType:3;
    uint8_t bubbleLevel;

    Vector2 position;
    Vector2 velocity;
    float bubbleMergeCooldown;
    float radius;
} Bubble;

#define MAX_BUBBLES 64

typedef struct Playfield
{
    Bubble bubbles[MAX_BUBBLES];
    Matrix transform;
    Vector2 fieldSize;
    float waterLevel;
    uint8_t nextBubbleLevel;
    uint8_t nextBubbleType;
} Playfield;

typedef struct GameTime
{
    float time;
    float deltaTime;
    float fixedTime;
    float fixedDeltaTime;
} GameTime;

#define COLOR_FROM_HEX(hexValue) (Color){((hexValue) >> 16) & 0xFF, ((hexValue) >> 8) & 0xFF, (hexValue) & 0xFF, 0xFF}
#endif